/// token.h header file
#include "std_lib_facilities.h"
#include <string>

const char let = 'L';
const char quit = 'Q';
const char print = ';';
const char number = '8';
const char name = 'a';
const char con    = 'C';    /// const declaration token
const string declkey = "let";		/// declaration keyword
const string constkey = "const";	/// const keyword
const string prompt  = "> ";
const string result  = "= "; /// used to indicate that what follows is a result


class Token {
public:
	char kind;
	double value;
	std::string name;
	Token(char ch) :kind(ch), value(0) { }
	Token(char ch, double val) :kind(ch), value(val) { }
	Token(char ch, std::string n) :kind(ch), name(n) { }
};

class Token_stream {
	bool full;
	Token buffer;
public:
	Token_stream() :full(0), buffer(0) { }

	Token get();
	void unget(Token t) { buffer=t; full=true; }

	void ignore(char);
};
